module OmniAuth
  module Whichsignupapi
    module Delegator
      include OmniAuth::Whichsignupapi::AuthHashDelegator

      def delegate_strategy
        return @delegate_strategy unless @delegate_strategy.nil?
        config = Devise.omniauth_configs[:whichsignupapi]
        @delegate_strategy = config.strategy_class.new(config.strategy_name, config.args.first)
      end
    end
  end
end