module OmniAuth
  module Whichsignupapi
    class TokenTools
      def initialize(password)
        @password = password
      end

      def generate_token(token_data)
        raise 'token generations not possible is token is blank' if token_data.blank?
        t = "#{token_data}|#{Time.now.to_i}"
        get_cipher.encrypt(t)
      end
      
      def decode_token(token)
        dec = get_cipher.decrypt(token)
        parts = dec.split('|')
        {
          time: parts.pop,
          token_data: parts.join('|')
        }
      end

      private

      def get_cipher
        Gibberish::AES::CBC.new(@password)
      end
    end
  end
end
